#include <stdlib.h>
#include <stdio.h>
#include <stdbool.h>

#define M 8
#define N 10
#define T 3

enum Zustand
{ wandernd, fressend, schlafend, ANZAHL_ZUSTAENDE };

typedef enum Zustand Zustand;

struct Tier
{
  Zustand z;
  int x;
  int y;
  int zeitdifferenz;
};

typedef struct Tier Tier;

Tier zoo[T];  

void fuelleZoo(Tier a[], int anzahl, int breite, int hoehe)
{
  for(int i = 0; i < anzahl; i++)
  {
    bool nochmalWuerfeln = true;
    while(nochmalWuerfeln)
    {
      a[i].x = rand() % breite;
      a[i].y = rand() % hoehe;
      nochmalWuerfeln = false;
      for(int j = 0; j < i; j++)
      {
        if(a[j].x == a[i].x && a[j].y == a[i].y)
        {
          nochmalWuerfeln = true;
          break;
        }
      }
    }
    a[i].zeitdifferenz = 0;
    a[i].z = rand() % ANZAHL_ZUSTAENDE;
  }
  
}

void ausgabeZoo(Tier a[], int anzahl, int breite, int hoehe)
{
  for(int y = 0; y < hoehe; y++)
  {
    for(int x = 0; x < breite; x++)
    {
      bool gefunden = false;
      for(int i = 0; i < anzahl; i++)
      {
        if(a[i].x == x && a[i].y == y)
        {
          putchar('0' + a[i].z); // TO DO: Buchstaben statt Ziffern
          gefunden = true;
          break;
        }
      }
      if(!gefunden)
      {
        putchar('.');
      }
    }
    putchar('\n');
  }
  putchar('\n'); 
}

void weiter(Tier a[], int anzahl, int breite, int hoehe)
{
  static int dx[] = {-1, 0, 1, -1, 1, 1, 0, -1};
  static int dy[] = {-1, -1, -1, 0, 0, 1, 1, 1};
  
  for(int i = 0; i < anzahl; i++)
  {
    a[i].zeitdifferenz++;
    
    switch(a[i].z)
    {
    case wandernd:
      int r = rand() % 8;
      int x = (a[i].x + dx[r] + breite) % breite;
      int y = (a[i].y + dy[r] + hoehe) % hoehe;
      bool besetzt = false;
      for(int j = 0; j < anzahl; j++)
      {
        if(j == i)
        {
          continue;
        }
        
        if(x == a[j].x && y == a[j].y)
        {
          besetzt = true;
          break;
        }
      }
      if(!besetzt)
      {
        a[i].x = x;
        a[i].y = y;
      }
      if(a[i].zeitdifferenz >= 5)
      {
        if(rand() % 2 == 0)
        {
          a[i].z = schlafend;
        }
        else
        {
          a[i].z = fressend;
        }
        a[i].zeitdifferenz = 0;
      }
      break;
    case fressend:
      if(a[i].zeitdifferenz >= 2)
      {
        a[i].z = wandernd;
        a[i].zeitdifferenz = 0;
      }     
      break;
    case schlafend:
      if(a[i].zeitdifferenz >= 10)
      {
        a[i].z = wandernd;
        a[i].zeitdifferenz = 0;
      }
      break;
    }
  }
}

int main( void )
{
  fuelleZoo(zoo, T, N, M);
  ausgabeZoo(zoo, T, N, M);
  
  for(int s = 0; s < 100; s++)
  {
    weiter(zoo, T, N, M);
    ausgabeZoo(zoo, T, N, M);
  }
  
  return 0;
}
